/*
    Rugam na purva, neshto oturva, bah toz simson
    Toi na mene shte mi pravi kurvenski fason
*/

#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cstring>
#include <cassert>
#include <vector>
#include <queue>
#include <stack>
#include <map>
#include <set>

typedef long long llong;
const int MAXN = 300000 + 10;
const int MAXLOG = 30;
const llong INF = 1e18;
const int INTINF = 1e9;

int n, m;
int a[MAXN];
int min[MAXN];
int max[MAXN];
std::vector <int> by_min[MAXN];
int dp[MAXN];

struct SegmentTree
{
    struct Node
    {
        int value;
        int lazy;

        Node()
        {
            value = lazy = 0;
        }
    };

    Node tree[4*MAXN];
    void push(int node, int l, int r)
    {
        if (tree[node].lazy == 0)
        {
            return;
        }

        tree[node].value += tree[node].lazy;
        if (l != r)
        {
            tree[2*node].lazy += tree[node].lazy;
            tree[2*node + 1].lazy += tree[node].lazy;
        }

        tree[node].lazy = 0;
    }

    void update(int l, int r, int node, int queryL, int queryR, int queryValue)
    {
        push(node, l, r);
        if (queryR < l || r < queryL)
        {
            return;
        }

        if (queryL <= l && r <= queryR)
        {
            tree[node].lazy += queryValue;
            push(node, l, r);
            return;
        }

        int mid = l + r >> 1;
        update(l, mid, 2*node, queryL, queryR, queryValue);
        update(mid + 1, r, 2*node + 1, queryL, queryR, queryValue);
        tree[node].value = std::min(tree[2*node].value, tree[2*node + 1].value);
    }

    int query(int l, int r, int node, int queryL, int queryR)
    {
        push(node, l, r);
        if (queryL <= l && r <= queryR)
        {
            return tree[node].value;
        }

        int ans = n;
        int mid = l + r >> 1;
        if (queryL <= mid) ans = std::min(ans, query(l, mid, 2*node, queryL, queryR));
        if (mid + 1 <= queryR) ans = std::min(ans, query(mid + 1, r, 2*node + 1, queryL, queryR));
        return ans;
    }

    void update(int l, int r, int val)
    {
        if (l > r) return;
        update(1, n + 1, 1, l, r, val);
    }

    int query(int idx)
    {
        return query(1, n + 1, 1, idx, n + 1);
    }
};

SegmentTree tree;
bool add[MAXN];
// int 

void solve()
{
    for (int i = 2 ; i <= n ; ++i)
    {
        max[i] = std::max(max[i], max[i - 1]);
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        by_min[min[i]].push_back(i);
    }

    for (int idx = n ; idx > 1 ; --idx)
    {
        if (add[idx])
        {
            tree.update(idx + 1, n + 1, 1);
        }
        for (const int &i : by_min[idx])
        {
            if (i < idx)
            {
                add[i] = true;
                continue;
            }

            // std::cout << "update: " << i + 1 << ' ' << min[i] << '\n'; 
            tree.update(i + 1, n + 1, 1);
        }
        
        // std::cout << "max: " << idx << ": " << max[idx - 1] << '\n';
        dp[idx] = tree.query(max[idx - 1] + 1);
        tree.update(idx, idx, dp[idx]);
        // std::cout << "dp: " << idx << " = " << dp[idx] << '\n';
    }

    std::cout << dp[2] << '\n';
}

void input()
{
    std::cin >> n >> m;
    std::fill(min + 1, min + 1 + n, n);
    std::iota(max + 1, max + 1 + n, 2);
    for (int i = 1 ; i <= m ; ++i)
    {
        int u, v;
        std::cin >> u >> v;
        min[u] = std::min(min[u], v);
        max[u] = std::max(max[u], v);
        min[v] = std::min(min[v], u);
        max[v] = std::max(max[v], u);
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}