/*
    Rugam na purva, neshto oturva, bah toz simson
    Toi na mene shte mi pravi kurvenski fason
*/

#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cstring>
#include <cassert>
#include <vector>
#include <queue>
#include <stack>
#include <map>
#include <set>

typedef long long llong;
const int MAXN = 300000 + 10;
const int MAXLOG = 30;
const llong INF = 1e18;
const int INTINF = 1e9;

int n;
llong a[MAXN];
llong p[MAXN];
llong suffix[MAXN];
llong suffixMIN[MAXN];

void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] *= n;
        p[i] = a[i] + p[i - 1];
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] -= p[n] / n;
    }

    int start = 1;
    llong sum = 0;
    for (int i = 1 ; i <= n ; ++i)
    {
        sum += a[i];
        if (sum > 0)
        {
            sum = 0;
            start = i + 1;
            continue;
        }
    }

    if (start == n + 1)
    {
        std::cout << "impossible\n";
        return;
    }

    sum = 0;
    llong max = 0;
    for (int i = start - 1 ; i >= 1 ; --i)
    {
        sum += a[i];
        max = std::max(max, sum);
    }

    for (int i = n ; i >= 1 ; --i)
    {
        suffix[i] = suffix[i + 1] + a[i];
        suffixMIN[i] = suffix[i];
        if (i < n) suffixMIN[i] = std::min(suffixMIN[i], suffixMIN[i + 1]);
    }

    for (int split = start ; split <= n ; ++split)
    {
        sum = suffix[start] - suffix[split + 1];
        if (sum + max > 0)
        {
            continue;
        }

        sum += max;
        if (sum + (suffix[split + 1] - suffixMIN[split + 1]) > 0)
        {
            continue;
        }

        for (int j = start ; j <= split ; ++j)
        {
            std::cout << j << ' ';
        }

        for (int j = start - 1 ; j >= 1 ; --j)
        {
            std::cout << j << ' ';
        }

        for (int j = split + 1 ; j <= n ; ++j)
        {
            std::cout << j << ' ';
        }

        return;
    }

    int best = n;
    int l, r = n;
    llong stop = 0;
    llong curr_min = 0;

    for (int i = n ; i >= start ; --i)
    {
        if (suffix[i] - suffix[best + 1] < curr_min)
        {
            curr_min = suffix[i] - suffix[best + 1];
            l = i;
            r = best;
            continue;
        }

        if (suffix[best + 1] < suffix[i])
        {
            best = i - 1;
        }
    }

    int split = r;
    start = l;

    sum = suffix[start] - suffix[split + 1];
    if (sum + max > 0)
    {
        std::cout << "impossible\n";
        return;
    }

    sum += max;
    if (sum + (suffix[split + 1] - suffixMIN[split + 1]) > 0)
    {
        std::cout << "impossible\n";
        return;
    }

    for (int j = start ; j <= split ; ++j)
    {
        std::cout << j << ' ';
    }

    for (int j = start - 1 ; j >= 1 ; --j)
    {
        std::cout << j << ' ';
    }

    for (int j = split + 1 ; j <= n ; ++j)
    {
        std::cout << j << ' ';
    }
}

void input()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}