#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int MAXN = 1e5 + 10, MAXM = 3e5 + 10;
int n, m;
vector < int > adj[MAXN], child[MAXN];
pair < int, int > cond[MAXM];
void input()
{
    cin >> n >> m;
    for (int i = 1; i < n; i ++)
    {

        int v, u;
        cin >> v >> u;
        adj[v].push_back(u);
        adj[u].push_back(v);
    }
    for (int i = 1; i <= m; i ++)
    {
        cin >> cond[i].first >> cond[i].second;
    }
}

int par[MAXN], ord[2 * MAXN], tin[MAXN], tout[MAXN], timer;
int depth[MAXN];

const int MAXLOG = 20;
int dp[MAXLOG][2 * MAXN], lg[2 * MAXN];
void build_sparse_table()
{
    for (int i = 1; i <= timer; i ++)
    {
        dp[0][i] = ord[i];
        lg[i] = lg[i / 2] + 1;
    }

    for (int j = 1; j < lg[timer]; j ++)
        for (int i = 1; i <= timer - (1 << j) + 1; i ++)
        {
            dp[j][i] = dp[j - 1][i + (1 << (j - 1))];
            if (depth[dp[j - 1][i]] < depth[dp[j][i]])
                dp[j][i] = dp[j - 1][i];
        }
}

int find_lca(int v, int u)
{
    int l = tin[v];
    int r = tin[u];
    if (l > r)
        swap(l, r);
    int len = lg[r - l + 1] - 1;
    int ans = dp[len][r - (1 << len) + 1];
    if (depth[dp[len][l]] < depth[ans])
        ans = dp[len][l];
    return ans;
}
void traverse(int v, int p)
{
    par[v] = p;
    tin[v] = ++ timer;
    ord[timer] = v;
    for (int u : adj[v])
    {
        if (u == p)
            continue;
        child[v].push_back(u);
        depth[u] = depth[v] + 1;
        traverse(u, v);
        ord[++ timer] = v;
    }
    tout[v] = timer;
}

bool in_subtree(int v, int u)
{
    return (tin[v] <= tin[u] && tout[u] <= tout[v]);
}

void impossible()
{
    cout << 0 << endl;
    exit(0);
}
vector < pair < int, int > > force[MAXN];
void attach_conditions()
{
    for (int i = 1; i <= m; i ++)
    {

        int v = cond[i].first, u = cond[i].second;

        if (in_subtree(v, u))
            continue;
        if (in_subtree(u, v))
        {
            impossible();
        }
        int lca = find_lca(v, u);
        int s1 = -1, s2 = -1;
        for (int j = 0; j < (int)(child[lca].size()); j ++)
        {
            int cur = child[lca][j];
            //cout << "check " << cur << endl;
            if (in_subtree(cur, v))
                s1 = j;
            if (in_subtree(cur, u))
                s2 = j;
        }
        //cout << "lca " << v << " " << u << " " << lca << " " << s1 << " " << s2 << endl;
        assert(s1 != -1 && s2 != -1 && s1 != s2);
        force[lca].push_back({s1, s2});
    }
}

const ll MOD = 1e9 + 7;
const int MAXD = 13;

ll fp[(1 << MAXD)];
int must[MAXD];
ll sub_calc(int v)
{

    int d = child[v].size();
    if (d == 0)
        return 1;
    for (int mask = 0; mask < (1 << d); mask ++)
    {
        fp[mask] = 0;
    }
    for (int i = 0; i < d; i ++)
        must[i] = 0;

    for (pair < int, int > cur : force[v])
    {
        ///cout << v << " force " << cur.first << " " << cur.second << endl;
        must[cur.second] |= (1 << cur.first);
        ///bef[cur.second].push_back(cur.first);
    }

    fp[0] = 1;

    for (int mask = 0; mask < (1 << d); mask ++)
    {

        for (int w = 0; w < d; w ++)
        {

            if ((mask & (1 << w)) > 0)
                continue;

            if ((mask & must[w]) != must[w])
                continue;
            int new_mask = (mask | (1 << w));


            fp[new_mask] += fp[mask];
            if (fp[new_mask] >= MOD)
                    fp[new_mask] -= MOD;
        }
    }
    //cout << v << " " << fp[(1 << d) - 1] << endl;
    return fp[(1 << d) - 1];
}
void do_math()
{
    ll res = 1;
    for (int i = 1; i <= n; i ++)
    {
        ll cur = sub_calc(i);
        res = (res * cur) % MOD;
    }
    cout << res << endl;
}
void solve()
{
    input();
    traverse(1, -1);
    build_sparse_table();
    attach_conditions();
    do_math();
}

int main()
{
    speed();
    solve();

    return 0;
}
