#include <bits/stdc++.h>

using namespace std;

const int maxn = 3000005;

int n;
int a[maxn], pos[maxn];

struct FenwickTree
{
    int tree[maxn];

    void update(int pos, int add)
    {
        for (; pos <= n; pos += (pos & (-pos)))
        {
            tree[pos] += add;
        }
    }

    int query(int pos)
    {
        int result = 0;

        for (; pos >= 1; pos -= (pos & (-pos)))
        {
            result += tree[pos];
        }

        return result;
    }
};

FenwickTree pref, suff;

long long prefInv[maxn], suffInv[maxn];

int main()
{
#ifndef LOCAL
std::ios_base::sync_with_stdio(false); std::cin.tie( NULL ); std::cout.tie( NULL );
#endif

    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
        pos[a[i]] = i;
    }

    for (int i = 1; i <= n; ++i)
    {
        prefInv[i] = prefInv[i - 1] + pref.query(n) - pref.query(pos[i]);
        pref.update(pos[i], +1);
    }

    for (int i = n; i >= 1; --i)
    {
        suffInv[i] = suffInv[i + 1] + suff.query(pos[i]);
        suff.update(pos[i], +1);
    }

    long long ans = (1LL << 60);

    for (int i = 1; i <= n; ++i)
    {
        ans = min(ans, prefInv[i - 1] + suffInv[i + 1]);
    }

    cout << ans << endl;

    return 0;
}
