#include<bits/stdc++.h>
#define MAXN 100001
#define LOGN 18
using namespace std;

const long long mod = 1e9 + 7;
int n, m;

vector<int> g[MAXN];
int jump[MAXN][LOGN];
int depth[MAXN];

void dfs(long long node, long long par, long long d)
{
    depth[node] = d;
    if (node == 1) jump[node][0] = 1;
    else jump[node][0] = par;

    for (auto to : g[node])
    {
        if (to != par)
        {
            dfs(to, node, d + 1);
        }
    }
}

long long findLCA(int& x,int& y)
{
    if (depth[x] < depth[y]) swap(x, y);
    long long diff = depth[x] - depth[y];

    for (long long i = 0; i < LOGN; ++i)
    {
        if ((diff & (1 << i)) != 0)
        {
            x = jump[x][i];
            diff -= (1 << i);
            if (diff == 0) break;
        }
    }

    if (x == y) return x;

    for (long long i = LOGN - 1; i >= 0; --i)
    {
        if (jump[x][i] != jump[y][i])
        {
            x = jump[x][i];
            y = jump[y][i];
        }
    }

    return jump[x][0];
}

long long dp[MAXN];
unordered_set<int> restrictions[MAXN];

void dfsAns(int node, int par)
{
    if (g[node].size() == 1 && node != 1)
    {
        dp[node] = 1;
        return;
    }

    vector<int> children;
    dp[node] = 1;

    for (auto to : g[node])
    {
        if (to != par)
        {
            dfsAns(to, node);
            children.push_back(to);
            dp[node] *= dp[to];
            dp[node] %= mod;
        }
    }

    sort(children.begin(), children.end());

    int cnt = 0;
    //cout << "on " << node << endl;

    do
    {
     //   cout << node << endl;
    //for (auto c : children) cout << c << " ";
    //cout << endl;

        bool fl = true;

        for (int i = 0; i < children.size(); ++i)
        {
            for (int j = i + 1; j < children.size(); ++j)
            {
                if (restrictions[children[i]].find(children[j]) != restrictions[children[i]].end())
                {
                    fl = false;
                    break;
                }
            }

            if (!fl) break;
        }
        cnt += fl;
        //cout << "now " << fl << endl;
    } while (next_permutation(children.begin(), children.end()));
    dp[node] = (dp[node] * (1LL * cnt)) % mod;
    //cout << "actual " << cnt << endl;
    //cout << "final " << node << " -> " << dp[node] << endl;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m;

    for (int i = 1; i < n; ++i)
    {
        int x, y;
        cin >> x >> y;
        g[x].push_back(y);
        g[y].push_back(x);
    }

    dfs(1, -1, 0);

    for (int log = 1; log < LOGN; ++log)
    {
        for (int i = 1; i <= n; ++i)
        {
            jump[i][log] = jump[jump[i][log - 1]][log - 1];
        }
    }

    for (int i = 1; i <= m; ++i)
    {
        int x, y, xx, yy;
        cin >> x >> y;

        xx = x;
        yy = y;

        int lca = findLCA(xx, yy);

        if (xx == yy)
        {
            if (depth[x] > depth[y])
            {
                cout << 0 << endl;
                return 0;
            }
        }
        else
        {
            // xx predi yy
            restrictions[xx].insert(y);
        }
    }

    dfsAns(1, -1);
    cout << dp[1] << endl;

    return 0;
}
